//
//  XYZViewController.m
//  MyApp
//
//  Created by eien.support@gmail.com on 2012/12/01.
//  Copyright (c) 2012年 Eien Factory. All rights reserved.
//

#import "XYZViewController.h"

@interface XYZViewController ()

@end

@implementation XYZViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)viewDidUnload {
    [self setTableView:nil];
    [super viewDidUnload];
}

-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return 2;
}

-(UITableViewCell*)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    UITableViewCell *aCell;
    if ( indexPath.row == 0 ) {
        aCell = [tableView dequeueReusableCellWithIdentifier:@"Cell1"];
        aCell.detailTextLabel.text = [self udidString];
    }
    else if ( indexPath.row == 1 ) {
        aCell = [tableView dequeueReusableCellWithIdentifier:@"Cell2"];
        aCell.detailTextLabel.text = [self uuidString];
    }
    return aCell;
}

- (NSString*)udidString {
    NSString    *uniqueID = [[UIDevice currentDevice] uniqueIdentifier];
    return uniqueID;
}

#define UUID_DEFAULTS_KEY   @"UUID"

- (NSString*)createNewUUID {
    CFUUIDRef   uuid = CFUUIDCreate(NULL);
    NSString    *uuidString = (__bridge NSString *)CFUUIDCreateString(NULL, uuid);
    CFRelease(uuid);
    return uuidString;
}

- (NSString*)loadUUID {
    NSString *uuidString = [[NSUserDefaults standardUserDefaults] stringForKey:UUID_DEFAULTS_KEY];
    return uuidString;
}

- (void)saveUUID:(NSString*)aString
{
    [[NSUserDefaults standardUserDefaults] setValue:aString forKey:UUID_DEFAULTS_KEY];
    [[NSUserDefaults standardUserDefaults] synchronize];
}

- (NSString*)uuidString {
    NSString *uuidString = [self loadUUID];
    if ( uuidString.length == 0 ) {
        uuidString = [self createNewUUID];
        [self saveUUID:uuidString];
    }
    return uuidString;
}

- (IBAction)refreshAction:(id)sender {
    [self.tableView reloadData];
}

- (IBAction)renewAction:(id)sender {
    [[NSUserDefaults standardUserDefaults] removeObjectForKey:UUID_DEFAULTS_KEY];
    [self.tableView reloadData];
}

@end
